package PMED1;

//   PMED1:          
//          : GUI,     . 
//      ,    ,     
//     GUI,     . 
//       :      GUI. 
//  ?     . 
//          . 


// :      ClanJavaTima .
abstract class Sef   // Mediator
{ abstract  String pripremiPonuduBP();
  abstract  String pripremiPonuduGUI();
  abstract  String pripremiPonuduAL();}

// :     ClanJavaTima .    ClanJavaTima  
//    .
class SefLaboratorije extends Sef    //ConcreteMediator
{ DusanSavic ds;  IlijaAntovic ia;  VojislavStanojevic vs;  MilosMilic mm;  ClanJavaTima cjt;
  SefLaboratorije()
   {  ds = new DusanSavic(this); ia = new IlijaAntovic(this); vs = new VojislavStanojevic(this); mm = new MilosMilic(this);}
  
  @Override
  String pripremiPonuduGUI(){return mm.pripremiPonudu();}
  @Override
  String pripremiPonuduAL(){return vs.pripremiPonudu();}
  @Override
  String pripremiPonuduBP(){return ia.pripremiPonudu();}

  public static void main(String arg[])
    { SefLaboratorije sf = new SefLaboratorije();
      sf.odrediKordinatoraPripremePonude();
      System.out.println(sf.kordinirajProcesPonude());
    }

void odrediKordinatoraPripremePonude() { cjt = ds;}   
String kordinirajProcesPonude(){ return cjt.kordinirajProcesPonude();}
}
// :  ClanJavaTima      Sef .  ClanJavaTima     Sef 
//            ClanJavaTima .
abstract class ClanJavaTima //Colleage
{  Sef sef;
   ClanJavaTima(Sef sef1) {sef = sef1;}
   String kordinirajProcesPonude() {return "";}
   abstract String pripremiPonudu();
}
class DusanSavic extends ClanJavaTima  //ConcreteColleague1
{ DusanSavic(Sef sef1) {super(sef1);}
  @Override
  String kordinirajProcesPonude(){ return sef.pripremiPonuduGUI() + " " +
     sef.pripremiPonuduAL() + " " + sef.pripremiPonuduBP();}
  @Override
  String pripremiPonudu(){return "Dusan Savic: Ponuda - Baza podataka";}}

class IlijaAntovic extends ClanJavaTima  //ConcreteColleague2
{ IlijaAntovic(Sef sef1) {super(sef1);}
  @Override
  String pripremiPonudu(){return "Ilija Antovic: Ponuda - Baza podataka";}}

class VojislavStanojevic extends ClanJavaTima  //ConcreteColleague3
{ VojislavStanojevic(Sef sef1) {super(sef1);}
  @Override
  String pripremiPonudu(){return " Vojislav Stanojevic: Ponuda - Aplikaciona logika";}}

class MilosMilic extends ClanJavaTima  //ConcreteColleague4
{ MilosMilic(Sef sef1) {super(sef1);}
  @Override
  String pripremiPonudu(){return " Milos Milic:  Ponuda - GUI";}}

