package PMEM2;

//   PMEM2:               . 
//                  
//     (   6 ).             
//     .               3 .
//         . 
//                       . 



// :    (KopijaPonude a).
class KopijaPonude  // Memento
{ Ponuda pon;
  void postaviPonudu(Ponuda pon) { this.pon=pon;}
  Ponuda uzmiPonudu() { return pon;}
}


// :     Memento .       Memento . 
class UpravaFakulteta  // CareTaker
{ 
  SILAB sil;
  KopijaPonude kp;

  UpravaFakulteta(SILAB sil) {this.sil = sil;}
  void kreirajPonudu(String nazivPonude) {sil.kreirajPonudu(nazivPonude);}
  void kreirajKopijuPonude(){ kp = sil.kreirajKopijuPonude();}
  String vratiPonudu(){return sil.vratiPonudu();}
  void vratiKopijuPonude(){sil.postaviPonudu(kp);}
  
  public static void main(String args[])
     {   
         JavaTimPonuda jat = new JavaTimPonuda();
         UpravaFakulteta uf = new UpravaFakulteta(jat); 
         /* Prva ponuda */
         uf.kreirajPonudu("prva");
         uf.kreirajKopijuPonude(); 
         System.out.println("Ponuda java tima: " + uf.vratiPonudu());
         
         /* Druga ponuda */
         uf.kreirajPonudu("druga");
         System.out.println("Ponuda java tima: " + uf.vratiPonudu());
         
         /* Vracanje na prvu ponudu */
         uf.vratiKopijuPonude();
         System.out.println("Ponuda java tima: " + uf.vratiPonudu());
   }
}

// :  Memento  (kp)      (kp.pon =  this.pon). Memento 
//     . 
abstract class  SILAB // Originator
{  ProgramskiJezik  pj;
    SUBP subp;
    String pv; // procenjeno vreme
    Ponuda pon;
    abstract void kreirajProgramskiJezik();
    abstract void kreirajSUBP();
    abstract void kreirajPonudu(String nazivPonude);
    public String vratiPonudu(){return pon.ponuda;}
    
    KopijaPonude kreirajKopijuPonude()
       { KopijaPonude kp = new KopijaPonude();
          kp.postaviPonudu(pon);
          return kp;
       }
    
      void postaviPonudu(KopijaPonude kp) {pon=kp.uzmiPonudu();} 
}
    


class Ponuda {String ponuda;}

class JavaTimPonuda extends SILAB
{ JavaTimPonuda() {}
  
  @Override
  public void kreirajProgramskiJezik(){pj = new Java();}
  @Override
  public void kreirajSUBP() { subp = new MySQL();}
  @Override
  public void kreirajPonudu(String nazivPonude) 
     {  pon = new Ponuda();
        kreirajProgramskiJezik(); 
        kreirajSUBP();   
        kreirajProcenjenoVreme(nazivPonude);
        pon.ponuda = "Programski jezik-" + pj.vratiProgramskiJezik() + " SUBP-" + subp.vratiSUBP() + " procenjeno vreme projekta: " + pv;
     }
  
  public void kreirajProcenjenoVreme(String nazivPonude) {pv = procVreme(nazivPonude);}
  String procVreme(String nazivPonude) 
      { if (nazivPonude.equals("prva")== true) return "3 meseca";
        if (nazivPonude.equals("druga")== true) return "6 meseci";
        return "";
      }
  
}

interface ProgramskiJezik {String vratiProgramskiJezik();}
class Java implements ProgramskiJezik{
 @Override
 public String vratiProgramskiJezik(){return "Java";}}
interface SUBP {String vratiSUBP();}
class MySQL implements SUBP {
 @Override
 public String vratiSUBP(){return "MySQL";}}

