package PVS2;

//   PVS2:             
//          .     
// Java     ,           .


class UpravaFakulteta // Client
 {
    SefLaboratorije sl;
    UpravaFakulteta(SefLaboratorije sl1) {sl=sl1;}

    public static void main(String[] arg)
    {  UpravaFakulteta uf;
       JavaTimPonuda jtp = new JavaTimPonuda();
       SefLaboratorije sl  = new SefLaboratorije();
       uf = new UpravaFakulteta(sl);
       uf.odrediOdgovornost(jtp);
         
  }
void odrediOdgovornost(SILAB sil){sl.odrediOdgovornost(sil);}

}
/* :          SILAB      . */
class SefLaboratorije  // ObjectStructure
{ ElementPonude el[];

  SefLaboratorije()
   {  el = new ElementPonude[2];
      el[0] = new Strategija();
      el[1] = new Metoda();
   }

  void odrediOdgovornost(SILAB s)
   {  el[0].odrediOdgovornost(s);
      el[1].odrediOdgovornost(s);
      System.out.println("Odgovoran za strategiju: " + el[0].vratiOdgovoran());
      System.out.println("Odgovoran za metodu: " + el[1].vratiOdgovoran());
    }
}

/* :   odrediOdgovornost()   SILAB   . */
abstract class ElementPonude   // Element
{ String odgovoran;
  abstract void odrediOdgovornost (SILAB s);  
  abstract String vratiOdgovoran();
}

class Strategija extends ElementPonude  // ConcreteElement1
{
  @Override
  void odrediOdgovornost (SILAB s) {s.koJeOdgovoranZaStrategiju(this);}
  void odgovoranZaStrategiju(String odgovoran1) {odgovoran = odgovoran1;}
  @Override
  String vratiOdgovoran() { return odgovoran;}
}

class Metoda extends ElementPonude // ConcreteElement2
{
  @Override
  void odrediOdgovornost (SILAB s) {s.koJeOdgovoranZaMetodu(this);}
  void odgovoranZaMetodu(String odgovoran1) {odgovoran = odgovoran1;}
  @Override
  String vratiOdgovoran() { return odgovoran;}
}

/* :  Visit()  (odgovoranZaStrategiju(),odgovoranZaMetodu()), VisitConcreteElementB())      (Strategija, Metoda).       Stategija  Metoda    SILAB        Stategija  Metoda .*/
abstract class SILAB // Visitor
{
  abstract void koJeOdgovoranZaStrategiju(Strategija s);
  abstract void koJeOdgovoranZaMetodu(Metoda m);
}


class JavaTimPonuda extends SILAB // ConcreteVisitor1
{
  @Override
  void koJeOdgovoranZaStrategiju(Strategija s){s.odgovoranZaStrategiju("Vojislav Stanojevic");}
  @Override
  void koJeOdgovoranZaMetodu(Metoda m){m.odgovoranZaMetodu("Milos Milic");}
}


class VBTimPonuda extends SILAB // ConcreteVisitor2
{
  @Override
  void koJeOdgovoranZaStrategiju(Strategija s){s.odgovoranZaStrategiju("Dusan Savic");}
  @Override
  void koJeOdgovoranZaMetodu(Metoda m){m.odgovoranZaMetodu("Ilija Antovic");}
}


